{$LINKLIB c}
UNIT GRAPHSDL;

interface
uses SDL, SDL_video; 
procedure initsdl;
procedure sdlline (xa, ya, xb, yb: integer);
procedure sdlcircle (x, y, radius: integer);
procedure sdlpixel (x,y:integer);
procedure updatesdlscreen;
procedure clearsdl;


implementation

const
	colordepth = 16;
	width=640; {insert pre-compiler directives}
	height=480;
type
	pixel = integer; {do we need this?}
	TpixelBuf=Array [0..height-1, 0..width-1] of Pixel;
	{will this be kept if the unit is called multiple times?}
var
	screen: PSDL_Surface;



procedure clearsdl;
var x,y: integer;
begin
	for x:=0 to width-1 do begin
		for y:=0 to height-1 do begin
			Tpixelbuf(screen^.pixels^)[y,x]:=0;
		end;
	end;
end;

procedure initsdl;
begin
	SDL_Init (SDL_INIT_VIDEO);
	screen:= SDL_SetVideoMode (width, height, colordepth, SDL_SWSURFACE);
   	if screen = nil then
   	Begin
   	    Writeln ('Couldn''t initialize video mode at ', width, 'x',
                height, 'x', colordepth, 'bpp') ;
       		Halt(1)
   	end ;
end;

procedure sdlline (xa, ya, xb, yb: integer);
var
slope: real;
i: integer;
newy, newx: integer;
begin
	{larger value -->xb. It doesn't matter in which direction the line is drawn...}
	SDL_locksurface (screen);
	if (abs(yb-ya)>abs(xb-xa)) {steep slope/horizontal}then {x depends on y}
	begin

		{for the line to look nicer, x will depend on y}
		writeln ('x depends on y');
		if ya>yb then begin {make ya<yb}
			i:=xb;
			xb:=xa;
			xa:=i;
			i:=ya;
			ya:=yb;
			yb:=i;
		end;
		slope:=(xb-xa)/(yb-ya);
		for i:=ya to yb do begin
			if (i<height-1) and (i>0) then begin
				newx:=round(xa+(i-ya)*slope);
				if (newx<width-1) and (newx>0) then begin
					Tpixelbuf(screen^.pixels^)[i,newx]:=30000; {get rid of that 30000}
				end;
			end;
		end;
	end
	{if just drawing a dot - otherwise it'll crash}
	else begin
		if (xa=xb) and (ya=yb) then begin
			if (xa<height-1) and (xa>0) then begin
				if (ya<height-1) and (ya>0) then begin
					Tpixelbuf(screen^.pixels^)[ya,xa]:=30000;
				end;
			end;
		end
	
		else begin
			writeln ('y depends on x');
			if xa>xb then begin
				i:=xb;
				xb:=xa;
				xa:=i;
				i:=ya;
				ya:=yb;
				yb:=i;
			end;
			slope:=((yb-ya)/(xb-xa));
			for i:=xa to xb do begin
				if (i<width-1) and (i>0) then begin
					newy:=round(ya+(i-xa)*slope);
					if (newy<height-1) and (newy>0) then
						Tpixelbuf(screen^.pixels^)[newy,i]:=30000; {get rid of that 30000}
				end;
			end;
		end;	
	end;
	SDL_unlocksurface (screen);
end;

procedure sdlcircle (x, y, radius: integer);
var i: integer;
var newy: integer;
begin
	SDL_locksurface (screen);
	for i:=-1*radius to radius do begin
		{if the sqr of a -tive number is not taken correctly, your fpc is too old!}
		if (x+i<width-1) and (x+i>0) then begin
			newy:=round(y+sqrt(sqr(radius)-sqr(i)));
			if (newy<height-1) and (newy>0) then
				Tpixelbuf(screen^.pixels^)[newy,x+i]:=30000;
			newy:=round(y-sqrt(sqr(radius)-sqr(i)));
			if (newy<height-1) and (newy>0) then
				Tpixelbuf(screen^.pixels^)[newy,x+i]:=30000;
		end;
		{the circle won't win a beauty contest, because there are a max of 2 y for 1 x}
	end;
	SDL_unlocksurface (screen);
end;

procedure sdlpixel (x: integer; y:integer);
begin
	SDL_locksurface (screen);
	Tpixelbuf(screen^.pixels^)[x,y]:=30000;
	SDL_unlocksurface (screen);
end;

procedure updatesdlscreen;
begin
	SDL_updaterect (screen,0,0,0,0);
end;

end.
